;
;	@file stacksize.asm
;	@brief fill stack area
;	@version $Revision: 1.1.1.1 $
;	@date $Date: 2006/04/25 22:13:39 $

%include "nasm.cfg"

		segment_data
keep_magic	dd 0
keep_size	dd 0
keep_stack	dd 0

		segment_text

proc	InitStackSize
		mov			eax, [esp+4]	; magic
		mov			edx, [esp+8]	; size
		and			edx, ~3
		jbe			.exit

		mov			[keep_magic], eax
		mov			[keep_size], edx

		lea			ecx, [edx - 4]
		sub			esp, edx
		mov			[keep_stack], esp
.lp:
		mov			[esp + ecx], eax
		sub			ecx, byte 4
		jge			.lp

		add			esp, edx
.exit:
		ret

proc	GetStackSize
		push		ebp
		mov			eax, [keep_magic]
		mov			edx, [keep_size]
		test		edx, edx
		jbe			.exit

		mov			ebp, [keep_stack]
		xor			ecx, ecx
.lp:
		cmp			[ebp + ecx], eax
		jnz			.break
		add			ecx, byte 4
		cmp			ecx, edx
		jl			.lp
		mov			eax, -1
		jmp			.exit
.break
		mov			eax, edx
		sub			eax, ecx

.exit
		pop			ebp
		ret

		end
